# Initially Auto-generated by EclipseNSIS Script Wizard
# 24-jul-2007 10:28:17
# Author: Carl Verbiest
# Description : Detect installed Progress version and create shortcut for selected version

Name "OpenEdge shortcuts"
BrandingText /TRIMLEFT "OpenEdge shortcut creator"

# Defines
!define REGKEY "SOFTWARE\$(^Name)"
!define TEMP1 $R0 ;Temp variable

# MUI defines
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_FINISHPAGE_NOAUTOCLOSE
!define MUI_STARTMENUPAGE_REGISTRY_ROOT HKLM
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_REGISTRY_KEY ${REGKEY}
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME StartMenuGroup
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "OpenEdge shortcuts"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"
!define MUI_UNFINISHPAGE_NOAUTOCLOSE

# Included files
!include Sections.nsh
!include MUI.nsh

# Variables
Var StartMenuGroup
Var Proversion
Var DLC


# Installer pages
!insertmacro MUI_PAGE_WELCOME
Page custom SetCustom ValidateCustom ": Options" ;Custom page. InstallOptions gets called in SetCustom.
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_STARTMENU Application $StartMenuGroup
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_PAGE_FINISH
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

# Installer languages
!insertmacro MUI_LANGUAGE English

;Use ReserveFile for your own InstallOptions INI files too!
ReserveFile "${NSISDIR}\Plugins\InstallOptions.dll"
ReserveFile "oeshort1.ini"

# Installer attributes
OutFile oeshort.exe
InstallDir "$PROGRAMFILES\OpenEdge shortcuts"
CRCCheck on
XPStyle on
ShowInstDetails show
InstallDirRegKey HKLM "${REGKEY}" Path
ShowUninstDetails show

# Installer sections
Section -Main SEC0000
    # Create shortcut uses OutPath as "start in" directory
    CreateDirectory $SMPROGRAMS\$StartMenuGroup
    SetOutPath $DLC
    CreateShortcut $SMPROGRAMS\$StartMenuGroup\Editor.lnk $DLC\bin\prowin32.exe
    WriteRegStr HKLM "${REGKEY}\Components" Main 1
SectionEnd

Section -post SEC0001
    WriteRegStr HKLM "${REGKEY}" Path $INSTDIR
    SetOutPath $INSTDIR
    WriteUninstaller $INSTDIR\uninstall.exe
    !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
    SetOutPath $SMPROGRAMS\$StartMenuGroup
    CreateShortcut "$SMPROGRAMS\$StartMenuGroup\Uninstall $(^Name).lnk" $INSTDIR\uninstall.exe
    !insertmacro MUI_STARTMENU_WRITE_END
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" DisplayName "$(^Name)"
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" DisplayIcon $INSTDIR\uninstall.exe
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" UninstallString $INSTDIR\uninstall.exe
    WriteRegDWORD HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" NoModify 1
    WriteRegDWORD HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" NoRepair 1
SectionEnd

# Macro for selecting uninstaller sections
!macro SELECT_UNSECTION SECTION_NAME UNSECTION_ID
    Push $R0
    ReadRegStr $R0 HKLM "${REGKEY}\Components" "${SECTION_NAME}"
    StrCmp $R0 1 0 next${UNSECTION_ID}
    !insertmacro SelectSection "${UNSECTION_ID}"
    GoTo done${UNSECTION_ID}
next${UNSECTION_ID}:
    !insertmacro UnselectSection "${UNSECTION_ID}"
done${UNSECTION_ID}:
    Pop $R0
!macroend

# Uninstaller sections
Section /o un.Main UNSEC0000
    Delete /REBOOTOK $SMPROGRAMS\$StartMenuGroup\Editor.lnk
    DeleteRegValue HKLM "${REGKEY}\Components" Main
SectionEnd

Section un.post UNSEC0001
    DeleteRegKey HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)"
    Delete /REBOOTOK "$SMPROGRAMS\$StartMenuGroup\Uninstall $(^Name).lnk"
    Delete /REBOOTOK $INSTDIR\uninstall.exe
    DeleteRegValue HKLM "${REGKEY}" StartMenuGroup
    DeleteRegValue HKLM "${REGKEY}" Path
    DeleteRegKey /IfEmpty HKLM "${REGKEY}\Components"
    DeleteRegKey /IfEmpty HKLM "${REGKEY}"
    RmDir /REBOOTOK $SMPROGRAMS\$StartMenuGroup
    RmDir /REBOOTOK $INSTDIR
SectionEnd

# Installer functions
Function .onInit
    InitPluginsDir
    File /oname=$PLUGINSDIR\oeshort1.ini "oeshort1.ini"
    Call getProversions
FunctionEnd

# Uninstaller functions
Function un.onInit
    ReadRegStr $INSTDIR HKLM "${REGKEY}" Path
    !insertmacro MUI_STARTMENU_GETFOLDER Application $StartMenuGroup
    !insertmacro SELECT_UNSECTION Main ${UNSEC0000}
FunctionEnd


Function getProversions
    
    push $0 # Counter
    push $1 # Version
    push $2 # DLC value
    push $3 # list
    
    StrCpy $0 0
    StrCpy $3 ""
    loop:
        EnumRegKey $1 HKCU Software\PSC\PROGRESS $0
        StrCmp $1 "" done
        # StrCmp $1 "10"
        ReadRegStr $2 HKCU Software\PSC\PROGRESS\$1\Startup\ DLC 
        StrCmp $2 "" loop
        StrCpy $Proversion $1
        StrCpy $3 "$3$1|"
        IntOp $0 $0 + 1
        goto loop
    done:
    StrLen $0 $3
    IntOp $0 $0 - 1
    StrCpy $3 $3 $0
    # MessageBox MB_OK $3
    
    WriteINIStr $PLUGINSDIR\oeshort1.ini "Field 1" ListItems $3
    WriteINIStr $PLUGINSDIR\oeshort1.ini "Field 1" State $Proversion
    
    pop $3
    pop $2
    pop $1
    pop $0
    
FunctionEnd

Function SetCustom
 
    # Display the InstallOptions dialog
 
    InstallOptions::dialog "$PLUGINSDIR\oeshort1.ini"
    ReadINIStr $1 "$PLUGINSDIR\oeshort1.ini" "Field 1" "State"
    ReadRegStr $DLC HKCU Software\PSC\PROGRESS\$1\Startup\ DLC 
    # MessageBox MB_OK|MB_ICONINFORMATION "Proversion=$1$\nDLC=$DLC"
 
FunctionEnd

Function ValidateCustom
 
ReadINIStr $Proversion "$PLUGINSDIR\oeshort1.ini" "Field 1" "State"
ReadRegStr $DLC HKCU Software\PSC\PROGRESS\$Proversion\Startup\ DLC 
FileOpen $1 $DLC\version r
FileRead $1 $2
# MessageBox MB_OK|MB_ICONINFORMATION "DLC=$DLC$\nProgress version : $2"
FileClose $1
 
 ; done:
  
FunctionEnd
